package org.apache.geronimo.samples.bank.web;

import java.io.IOException;
import java.util.Collection;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.geronimo.samples.bank.ejb.BankManagerFacadeHomeLocal;
import org.apache.geronimo.samples.bank.ejb.BankManagerFacadeLocal;
import org.apache.geronimo.samples.bank.ejb.CustomerLocal;


/**
 * 
 * @author Lasantha Ranaweera
 *
 */
public class CustomerServiceServlet extends HttpServlet {

	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		viewCustomerInfo(req, res);
	}

	protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		doGet(req,res);
	}
	
	private void viewCustomerInfo(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		Context context = null; 
		String path = "/jsp/error.jsp";;
		try {
			String customerCode = req.getParameter("customerCode");			
			
			context = new InitialContext();
			BankManagerFacadeHomeLocal bmHome = (BankManagerFacadeHomeLocal)context.lookup(BankManagerFacadeHomeLocal.JNDI_NAME);
			BankManagerFacadeLocal bm = bmHome.create();
			
			Collection accountList = bm.getAccountInformation(customerCode);
			CustomerLocal customer = bm.getCustomer(customerCode);
			
			
			if(accountList != null && customer!= null){
				
				req.setAttribute("accountList",accountList);
				req.setAttribute("customerCode",customerCode);
				req.setAttribute("customerName",customer.getCustomerName());
				path = "/jsp/customer_info.jsp";
				
			}		
			
		} catch (Exception e) {
			e.printStackTrace();
		}finally{
			try {
				context.close();
			} catch (NamingException e) {
				e.printStackTrace();
			}
		}
		
	  getServletContext().getRequestDispatcher(path).forward(req,res);
	}

}
